diff -arcN emacs-18.55/src/keyboard.c nemacs-3.3.2/src/keyboard.c
*** emacs-18.55/src/keyboard.c	Thu Jul 20 14:32:59 1989
--- nemacs-3.3.2/src/keyboard.c	Wed Jun  6 03:18:09 1990
***************
*** 1,3 ****
--- 1,12 ----
+ /* 87.6.6   modified by K.Handa */
+ /* 87.6.13  modified by K.Handa */
+ /* 87.12.19 modified for Nemacs Ver.2.0 by K.Handa */
+ /* 88.4.27  modified by Y.Ishikawa */
+ /* 88.5.26  modified for Nemacs Ver.2.1 by K.Handa */
+ /* 89.2.10  modified for Nemacs Ver.3.0 by K.Handa */
+ /* 89.12.20 modified for Nemacs Ver.3.2.3 by K.Handa
+ 	Handle C-g correctly when kanji-input-code is Shift-JIS */
+ 
  /* Keyboard input; editor command loop.
     Copyright (C) 1985, 1986, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 39,44 ****
--- 48,57 ----
  
  extern int errno;
  
+ #ifdef NEMACS  /* 87.6.5  by K.Handa */
+ #include "kanji.h"
+ #endif
+ 
  /* Get FIONREAD, if it is available.  */
  #ifdef USG
  #include <termio.h>
***************
*** 204,209 ****
--- 217,225 ----
  #undef SIGIO
  #endif
  #endif
+ #ifdef NEMACS  /* by Y.Ishikawa */
+ int DisableUndo;
+ #endif
  
  /* Function for init_keyboard to call with no args (if nonzero).  */
  void (*keyboard_init_hook) ();
***************
*** 488,494 ****
--- 504,515 ----
    Lisp_Object cmd;
    int lose;
    int nonundocount;
+ #ifdef NEMACS  /* 87.6.6  by K.Handa */
+   unsigned char keybuf[30];
+   int kanji1, kanji2;
+ #else
    char keybuf[30];
+ #endif
    int i;
    int no_redisplay;
    int no_direct;
***************
*** 559,564 ****
--- 580,589 ----
  
        last_command_char = keybuf[i - 1];
        
+ #ifdef NEMACS  /* 87.6.6  by K.Handa */
+       kanji1 = keybuf[0];  kanji2 = keybuf[1];
+ #endif
+ 
        cmd = read_key_sequence_cmd;
        if (!NULL (Vexecuting_macro))
  	{
***************
*** 591,598 ****
--- 616,629 ----
  	    {
  	      if (EQ (cmd, Qforward_char) && point <= NumCharacters)
  		{
+ #ifdef NEMACS  /* 89.3.10  by K.Handa */
+ 		  int saved_point = point;
+ #endif NEMACS
  		  lose = CharAt (point);
  		  SetPoint (point + 1);
+ #ifdef NEMACS  /* 89.3.10  by K.Handa */
+ 		  if (point == saved_point) point += 2;
+ #endif
  		  if (lose >= ' ' && lose < 0177
  		      && (XFASTINT (XWINDOW (selected_window)->last_modified)
  			  >= bf_modified)
***************
*** 621,632 ****
--- 652,672 ----
  		    no_redisplay = direct_output_forward_char (-1);
  		  goto directly_done;
  		}
+ #ifdef NEMACS  /* 87.6.2  by K.Handa */
+    	      else if (EQ (cmd, Qself_insert_command) ||
+ 		       EQ (cmd, Qkanji_self_insert))
+ #else
  	      else if (EQ (cmd, Qself_insert_command))
+ #endif
  		{
  		  if (NULL (Vexecuting_macro) &&
  		      !EQ (minibuf_window, selected_window))
  		    {
+ #ifdef NEMACS  /* by Y.Ishikawa */
+ 		      if (!DisableUndo && (!nonundocount || nonundocount >= 20))
+ #else
  		      if (!nonundocount || nonundocount >= 20)
+ #endif
  			{
  			  Fundo_boundary ();
  			  nonundocount = 0;
***************
*** 642,652 ****
--- 682,707 ----
  		    || !EQ (bf_cur->selective_display, Qnil)
  		    || detect_input_pending ()
  		    || !NULL (Vexecuting_macro);
+ #ifdef NEMACS  /* 87.6.6  by K.Handa */
+ 		  if (EQ (cmd, Qkanji_self_insert)) {
+ /* modified by K.Handa  87.6.13 */
+ /* modified by K.Handa  87.12.10 */
+ 		    SelfInsert (kanji1, 1);
+ 		    lose = 0;
+ 		    if (SelfInsert (kanji2, 0)) {
+ 		      lose = 1;
+ 		      nonundocount = 0;
+ 		    }
+ 		  } else {
+ #endif  /* NEMACS */
  		  if (SelfInsert (last_command_char, 0))
  		    {
  		      lose = 1;
  		      nonundocount = 0;
  		    }
+ #ifdef NEMACS  /* 87.6.6  by K.Handa */
+   		  }
+ #endif
  		  if (!lose
  		      && (point == NumCharacters + 1 || CharAt (point) == '\n')
  		      && last_command_char >= ' '
***************
*** 660,666 ****
--- 715,725 ----
  	  /* Here for a command that isn't executed directly */
  
  	  nonundocount = 0;
+ #ifdef NEMACS  /* by Y.Ishikawa */
+ 	  if (!DisableUndo && NULL (Vprefix_arg) && NULL (Vexecuting_macro) &&
+ #else
  	  if (NULL (Vprefix_arg) && NULL (Vexecuting_macro) &&
+ #endif
  	      !EQ (minibuf_window, selected_window))
  	    Fundo_boundary ();
  	  Fcommand_execute (cmd, Qnil);
***************
*** 807,813 ****
--- 866,879 ----
  
    if (c < 0) return -1;
  
+ #ifdef NEMACS  /* 87.6.2  by K.Handa */
+   c &= (MetaFlag
+ 	|| (!NULL(bf_cur->kanji_flag)
+ 	    && XFASTINT (kanji_input_code) != JIS
+ 	    && XFASTINT (kanji_input_code) != NOCONV) ? 0377 : 0177);
+ #else
    c &= MetaFlag ? 0377 : 0177;
+ #endif
  
    if (XTYPE (Vkeyboard_translate_table) == Lisp_String
        && XSTRING (Vkeyboard_translate_table)->size > c)
***************
*** 893,900 ****
--- 959,974 ----
  {
    c &= 0377;
  
+ #ifdef NEMACS  /* 87.6.2, 89.12.20  by K.Handa */
    if (c == Ctl ('g')
+       || ((c == (0200 | Ctl ('g')))
+ 	  && !MetaFlag
+ 	  && (NULL (bf_cur->kanji_flag)
+ 	      || XFASTINT (kanji_input_code) != Shift_JIS)))
+ #else
+   if (c == Ctl ('g')
        || ((c == (0200 | Ctl ('g'))) && !MetaFlag))
+ #endif
      {
        interrupt_signal ();
        return;
***************
*** 978,984 ****
--- 1052,1064 ----
    input_pending = --kbd_count > 0;
    c = *kbd_ptr;			/* *kbd_ptr++ would have a timing error. */
    kbd_ptr++;			/* See kbd_buffer_store_char. */
+ #ifdef NEMACS  /* 88.1.4, 88.5.26  by K.Handa */
+   return (c & ((MetaFlag
+ 		|| (XFASTINT(kanji_input_code) != JIS
+ 		    && XFASTINT(kanji_input_code) != NOCONV)) ? 0377 : 0177));
+ #else
    return (c & (MetaFlag ? 0377 : 0177)); /* Clean up if sign was extended. */
+ #endif
  }
  
  /* Force an attempt to read input regardless of what FIONREAD says.  */
***************
*** 1299,1304 ****
--- 1379,1411 ----
      EchoThem (1);
  
    nextc = get_char (nodisplay ? -1 : !prompt);
+ #ifdef NEMACS  /* 87.6.2, 87.12.10  by K.Handa */
+   if ((!NULL (bf_cur->kanji_flag)
+        && XFASTINT(kanji_input_code) != JIS
+        && XFASTINT(kanji_input_code) != NOCONV
+        && nextc >= 0x80)
+ /* modified by K.Handa  88.5.26 */
+       || (kanji_JIS_flag && JIS_P(nextc))) {
+     switch (XFASTINT (kanji_input_code)) {
+     case EUC:
+       keybuf[0] = (unsigned char)nextc;
+       keybuf[1] = (unsigned char)get_char (-1);
+       break;
+     case Shift_JIS:
+       c = get_char (-1);	/* patch by t-ishii@srash.sra.junet */
+       S2E (nextc, c, keybuf[0], keybuf[1]);
+       break;
+     case JIS:
+       keybuf[0] = (unsigned char)nextc | 0x80;
+       keybuf[1] = (unsigned char)get_char (-1) | 0x80;
+       break;
+     }
+     read_key_sequence_cmd = Qkanji_self_insert;
+     keys_prompt = 0;
+     Vquit_flag = Qnil;
+     return 2;
+   }
+ #endif  /* NEMACS */
    nextlocal = bf_cur->keymap;
    XSET (nextglobal, Lisp_Vector, CurrentGlobalMap);
  
***************
*** 1994,1999 ****
--- 2101,2112 ----
  Each character is looked up in this string and the contents used instead.\n\
  If string is of length N, character codes N and up are untranslated."); 
    Vkeyboard_translate_table = Qnil;
+ #ifdef NEMACS  /* by Y.Ishikawa */
+   DEFVAR_BOOL ("disable-undo", &DisableUndo,
+     "*Nil means undo facility is active.\n\
+ This feature is only available in Nemacs.");
+   DisableUndo = 0;
+ #endif  /* NEMACS */
  }
  
  keys_of_keyboard ()
diff -arcN emacs-18.55/src/keymap.c nemacs-3.3.2/src/keymap.c
*** emacs-18.55/src/keymap.c	Fri Feb 24 20:36:05 1989
--- nemacs-3.3.2/src/keymap.c	Wed Jun  6 03:18:10 1990
***************
*** 1,3 ****
--- 1,7 ----
+ /* 88.5.28  modified for Nemacs Ver.2.1 by K.Handa */
+ /* 88.12.14 modified for Nemacs Ver.3.2.1 by K.Handa
+ 	In Ftext_char_description, '& 0377' is omitted. */
+ 
  /* Manipulation of keymaps
     Copyright (C) 1985, 1986, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 716,721 ****
--- 720,731 ----
       register unsigned int c;
       register char *p;
  {
+ #ifdef NEMACS  /* 88.5.28  by K.Handa */
+   if (c >= 0400) {
+     *p++ = c >> 8;
+     *p++ = c & 0377;
+   } else {
+ #endif
    if (c >= 0200)
      {
        *p++ = 'M';
***************
*** 734,739 ****
--- 744,752 ----
      }
    else
      *p++ = c;
+ #ifdef NEMACS  /* 88.5.28  by K.Handa */
+   }
+ #endif
    return p;  
  }
  
***************
*** 747,753 ****
--- 760,770 ----
  
    CHECK_NUMBER (chr, 0);
  
+ #ifdef NEMACS  /* 89.12.14  by K.Handa */
+   *push_text_char_description (XINT (chr), tem) = 0;
+ #else
    *push_text_char_description (XINT (chr) & 0377, tem) = 0;
+ #endif
  
    return build_string (tem);
  }
diff -arcN emacs-18.55/src/lisp.h nemacs-3.3.2/src/lisp.h
*** emacs-18.55/src/lisp.h	Wed Mar 30 15:42:49 1988
--- nemacs-3.3.2/src/lisp.h	Wed Jun  6 03:18:13 1990
***************
*** 470,476 ****
--- 470,483 ----
      Lisp_Object chain;
      int bufpos;
      int modified;
+ /* patch for point_type_marker by K.Handa 89.11.30 */
+     int type;
    };
+ /* patch for point_type_marker by K.Handa 89.11.30 */
+ #define MARKER_OLD_TYPE 1
+ #define MARKER_POINT_TYPE 2
+ #define MARKER_ALL_TYPE  (MARKER_OLD_TYPE | MARKER_POINT_TYPE)
+ /* end of patch */
  
  /* Data type checking */
  
diff -arcN emacs-18.55/src/lread.c nemacs-3.3.2/src/lread.c
*** emacs-18.55/src/lread.c	Tue Aug  2 10:43:43 1988
--- nemacs-3.3.2/src/lread.c	Fri Jun  8 00:50:16 1990
***************
*** 1,3 ****
--- 1,9 ----
+ /* 89.10.24 modified for Nemacs Ver.3.2 by K.Handa */
+ /* 90.1.26  modified for Nemacs Ver.3.3.1 by K.Handa
+ 		close 'fd' after load-hook */
+ /* 90.6.6   modified for Nemacs Ver.3.3.2 by abe@sunrise.hallab.co.jp
+ 	'GCPRO2(str, f)' in Fload() */
+ 
  /* Lisp parsing and input streams.
     Copyright (C) 1985, 1986, 1987 Free Software Foundation, Inc.
  
***************
*** 58,63 ****
--- 64,74 ----
  /* For use within read-from-string (this reader is non-reentrant!!) */
  static int read_from_string_index;
  static int read_from_string_limit;
+ 
+ #ifdef NEMACS	/* 89.10.24  by K.Handa */
+ /* Hook run by `load' before it does really loading.  */
+ Lisp_Object Vload_hook;
+ #endif
  
  /* Handle unreading and rereading of characters.
   Write READCHAR to read a character, UNREAD(c) to unread c to be read again. */
***************
*** 187,192 ****
--- 198,207 ----
    register FILE **ptr;
    int count = specpdl_ptr - specpdl;
    struct gcpro gcpro1;
+ #ifdef NEMACS	/* 89.10.24  by K.Handa */
+   struct gcpro gcpro2;		/* 90.6.6 by abe@sunrise.hallab.co.jp */
+   Lisp_Object f;
+ #endif
  
    CHECK_STRING (str, 0);
    str = Fsubstitute_in_file_name (str);
***************
*** 195,201 ****
--- 210,220 ----
       since it would try to load a directory as a Lisp file */
    if (XSTRING (str)->size > 0)
      {
+ #ifdef NEMACS	/* 89.10.24  by K.Handa */
+       fd = openp (Vload_path, str, !NULL (nosuffix) ? "" : ".elc:.el:", &f, 0);
+ #else
        fd = openp (Vload_path, str, !NULL (nosuffix) ? "" : ".elc:.el:", 0, 0);
+ #endif
      }
  
    if (fd < 0)
***************
*** 215,226 ****
--- 234,252 ----
    if (NULL (nomessage))
      message ("Loading %s...", XSTRING (str)->data);
  
+ #ifdef NEMACS   /* 90.6.6  by abe@sunrise.hallab.co.jp */
+   GCPRO2 (str, f);
+ #else
    GCPRO1 (str);
+ #endif
    ptr = (FILE **) xmalloc (sizeof (FILE *));
    *ptr = stream;
    XSET (lispstream, Lisp_Internal_Stream, (int) ptr);
    record_unwind_protect (load_unwind, lispstream);
    load_in_progress++;
+ #ifdef NEMACS	/* 89.10.24, 90.1.26  by K.Handa */
+   if (NULL(Vload_hook) || NULL(call2(Vload_hook, f, nomessage)))
+ #endif	/* NEMACS */
    readevalloop (Qget_file_char, stream, Feval, 0);
    unbind_to (count);
    UNGCPRO;
***************
*** 1294,1299 ****
--- 1320,1333 ----
  Initialized based on EMACSLOADPATH environment variable, if any,\n\
  otherwise to default specified in by file paths.h when emacs was built.");
  
+ #ifdef NEMACS	/* 89.10.22  by K.Handa */
+   Vload_hook = Qnil;
+ 
+   DEFVAR_LISP ("load-hook", &Vload_hook,
+     "Function called, if non-nil, before loading\n\
+ with two arguments, FILENAME and NOMESSAGE.\n\
+ If this function returns nil, normal loading procedure is executed.");
+ #endif
    DEFVAR_BOOL ("load-in-progress", &load_in_progress,
      "Non-nil iff inside of  load.");
  
diff -arcN emacs-18.55/src/marker.c nemacs-3.3.2/src/marker.c
*** emacs-18.55/src/marker.c	Thu Oct  2 11:59:17 1986
--- nemacs-3.3.2/src/marker.c	Wed Jun  6 03:18:35 1990
***************
*** 139,144 ****
--- 139,170 ----
    return marker;
  }
  
+ /* patch for point_type_marker by K.Handa  89.11.30 */
+ DEFUN ("set-marker-type", Fset_marker_type, Sset_marker_type, 2, 2, 0,
+   "Set type of marker MARKER to point_type if POINT_TYPE is not\n\
+ NIL, otherwise set to conventional type.  Returns MARKER.\n\
+ 'point_type' means that 'insert' at that type of marker moves\n\
+ the marker forward (i.e. to the tail of text) just like 'point'.")
+   (marker, type)
+      Lisp_Object marker, type;
+ {
+   CHECK_MARKER (marker, 0);
+   XMARKER (marker)->type = (NULL(type)) ? MARKER_OLD_TYPE : MARKER_POINT_TYPE;
+   return marker;
+ }
+ 
+ DEFUN ("marker-point-type", Fmarker_point_type, Smarker_point_type, 1, 1, 0,
+   "T if type of marker MARKER is point_type, otherwize NIL.")
+   (marker)
+      Lisp_Object marker;
+ {
+   CHECK_MARKER (marker, 0);
+   if (XMARKER (marker)->type == MARKER_POINT_TYPE) return Qt;
+   else return Qnil;
+ }
+ 
+ /* end of patch */
+ 
  /* This is called during garbage collection,
   so we must be careful to ignore and preserve mark bits,
   including those in chain fields of markers.  */
***************
*** 232,237 ****
--- 258,265 ----
  		       ((XTYPE (marker) == Lisp_Marker)
  			? Fmarker_buffer (marker)
  			: Qnil));
+ /* patch for point_type_marker by K.Handa 89.11.30 */
+ 	  XMARKER (new)->type = XMARKER (marker)->type;
  	  return new;
  	}
        else
***************
*** 244,248 ****
--- 272,280 ----
    defsubr (&Smarker_position);
    defsubr (&Smarker_buffer);
    defsubr (&Sset_marker);
+ /* patch for point_type_marker by K.Handa 89.11.30 */
+   defsubr (&Sset_marker_type);
+   defsubr (&Smarker_point_type);
+ /* end of patch */
    defsubr (&Scopy_marker);
  }
diff -arcN emacs-18.55/src/nconfig.h nemacs-3.3.2/src/nconfig.h
*** emacs-18.55/src/nconfig.h	Thu Jan  1 09:00:00 1970
--- nemacs-3.3.2/src/nconfig.h	Wed Jun  6 03:19:20 1990
***************
*** 0 ****
--- 1,47 ----
+ /* Nemacs site configuration file
+    Coded by K.Handa, Electrotechnical Lab. (handa@elt.go.jp)
+ 
+    This file is part of Nemacs (Japanese version of GNU Emacs).
+ 
+    Nemacs is distributed in the forms of patches to GNU
+    Emacs under the terms of the GNU EMACS GENERAL PUBLIC
+    LICENSE which is distributed along with GNU Emacs by the
+    Free Software Foundation.
+ 
+    Nemacs is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied
+    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+    PURPOSE.  See the GNU EMACS GENERAL PUBLIC LICENSE for
+    more details.
+ 
+    You should have received a copy of the GNU EMACS GENERAL
+    PUBLIC LICENSE along with Nemacs; see the file COPYING.
+    If not, write to the Free Software Foundation, 675 Mass
+    Ave, Cambridge, MA 02139, USA. */
+ 
+ /* 90.2.27  created for Nemacs Ver.3.3.1 by K.Handa */
+ 
+ #ifdef NEMACS
+ 
+ /* define EGG if you want to use EGG */
+ #define EGG
+ 
+ #ifdef EGG
+ /* define one of WNN3, WNN4, and WNN4V3 */
+ #define WNN4V3
+ #endif
+ 
+ #ifdef WNN4V3
+ #define LIBWNN /usr/local/wnn4/jlib.V3/libjd.a
+ #define INCWNN -I/usr/local/wnn4/include
+ #else   /* not WNN4V3 */
+ #ifdef WNN3
+ #define LIBWNN /usr/local/wnn3/jlib/libjd.a
+ #define INCWNN -I/usr/local/wnn3/include
+ #else   /* not WNN4V3 nor WNN3 */
+ #define LIBWNN
+ #define INCWNN
+ #endif  /* not WNN3 */
+ #endif  /* not WNN4V3 */
+ 
+ #endif  /* NEMACS */
diff -arcN emacs-18.55/src/process.c nemacs-3.3.2/src/process.c
*** emacs-18.55/src/process.c	Mon Aug  7 07:01:31 1989
--- nemacs-3.3.2/src/process.c	Wed Jun  6 03:18:26 1990
***************
*** 1,3 ****
--- 1,12 ----
+ /* modified by A.Kato(kato@koudai.cs.titech.junet)  87.7.7 */
+ /* 88.1.20  modified for Nemacs Ver.2.0 by K.Handa */
+ /* 88.1.19  modified by K.Handa according to a patch by Mr.Sanewo (88.3.6) */
+ /* 88.5.19  modified for Nemacs Ver.2.1 by K.Handa */
+ /* 89.3.23  modified for Nemacs Ver.3.0 by K.Handa, S.Tomura */
+ /* 89.9.12  modified for nemacs Ver.3.2 by S.Tomura */
+ /* 90.2.28  modified for Nemacs Ver.3.3.1 by abe@sunrise.hallab.co.jp
+ 	do GCPRO (proc) before Ffuncall */
+ 
  /* Asynchronous subprocess control for GNU Emacs.
     Copyright (C) 1985, 1986, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 90,95 ****
--- 99,107 ----
  #include "termhooks.h"
  #include "termopts.h"
  #include "commands.h"
+ #ifdef NEMACS  /* 89.2.22  by K.Handa */
+ #include "kanji.h"
+ #endif
  
  /* a process object is a network connection when its childp field is neither
     Qt nor Qnil but is instead a string (name of foreign host we
***************
*** 223,228 ****
--- 235,247 ----
     Always -1 on systems that support FIONREAD.  */
  
  int proc_buffered_char[MAXDESC];
+ 
+ #ifdef NEMACS  /* 87.7.7 by A.Kato  89.2.21 by K.Handa */
+ Lisp_Object Qinvoke_find_kanji_process_code;
+ Lisp_Object Qfind_kanji_process_code;
+ 
+ int kanji_mode[MAXDESC];
+ #endif
  
  #ifdef HAVE_PTYS
  
***************
*** 885,890 ****
--- 904,930 ----
    XPROCESS (proc)->sentinel = Qnil;
    XPROCESS (proc)->filter = Qnil;
    XPROCESS (proc)->command = Flist (nargs - 2, args + 2);
+ #ifdef NEMACS  /* 89.2.10  by K.Handa, S.Tomura 89.9.12 by S.Tomura */
+   {
+     Lisp_Object code = Qnil;
+     if (EQ (Fboundp(Qfind_kanji_process_code), Qt)) {
+       int i;
+       struct gcpro gcpro1;	/* 90.2.28  by S.Abe */
+       Lisp_Object *newargs
+ 	= (Lisp_Object *) alloca((sizeof (Lisp_Object *)) * (nargs + 1));
+       newargs[0] = Qinvoke_find_kanji_process_code;
+       newargs[1] = NULL(buffer) ? Qnil : Fbuffer_name(buffer);
+       newargs[2] = program;
+       newargs[3] = Qnil;
+       for (i = 3; i < nargs; i++) newargs[i+1] = args[i];
+       GCPRO1 (proc);		/* 90.2.28  by S.Abe */
+       code = Ffuncall (nargs + 1, newargs);
+       UNGCPRO;			/* 90.2.28  by S.Abe */
+     }
+     if (XTYPE(code) != Lisp_Int) code = make_number (NOCONV);
+     XPROCESS (proc)->kanji_code = code;
+   }
+ #endif
  
    create_process (proc, new_argv);
  
***************
*** 1193,1198 ****
--- 1233,1257 ----
    XFASTINT (XPROCESS (proc)->infd) = s;
    XFASTINT (XPROCESS (proc)->outfd) = outch;
    XFASTINT (XPROCESS (proc)->flags) = RUNNING;
+ #ifdef NEMACS  /* 89.2.10  by K.Handa 89.9.12 by S.Tomura */
+   {
+     Lisp_Object code = Qnil;
+     if (EQ (Fboundp (Qfind_kanji_process_code), Qt)) {
+       Lisp_Object args[5];
+       struct gcpro gcpro1;	/* 90.2.28  by S.Abe */
+       args[0] = Qinvoke_find_kanji_process_code;
+       args[1] = NULL(buffer) ? Qnil : Fbuffer_name(buffer);
+       args[2] = service;
+       args[3] = Qt;
+       args[4] = host;
+       GCPRO1 (proc);		/* 90.2.28  by S.Abe */
+       code = Ffuncall (5, args);
+       UNGCPRO;			/* 90.2.28  by S.Abe */
+     }
+     if (XTYPE(code) != Lisp_Int) code = make_number (NOCONV);
+     XPROCESS (proc)->kanji_code = code;
+   }
+ #endif
    input_wait_mask |= ChannelMask (inch);
    return proc;
  }
***************
*** 1218,1223 ****
--- 1277,1285 ----
        XFASTINT (p->infd) = 0;
        XFASTINT (p->outfd) = 0;
        chan_process[inchannel] = Qnil;
+ #ifdef NEMACS  /* 88.5.19  by K.Handa */
+       kanji_mode[inchannel] = 0;
+ #endif
        input_wait_mask &= ~ChannelMask (inchannel);
      }
  }
***************
*** 1553,1558 ****
--- 1615,1634 ----
     If you want to read all available subprocess output,
     you must call it repeatedly until it returns zero.  */
  
+ /* patch by A.Kato  87.7.7
+  * #ifdef KANJI
+  * #endif
+  * is provided to handle kanji code conversion.
+  *                              -- kato@cs.titech.junet
+  * The convention described above is changed into conventional nemacs
+  * patch style.  K.Handa  88.5.19.
+  * And now modified again as follows:
+  * #ifdef NEMACS
+  * #endif
+  * read_process_output returns 1 if there's real output from process but
+  * it must be pended until next one or two chars are received.
+  * end of patch */
+ 
  read_process_output (proc, channel)
       Lisp_Object proc;
       register int channel;
***************
*** 1564,1583 ****
--- 1640,1686 ----
    register struct Lisp_Process *p = XPROCESS (proc);
    register int opoint;
  
+ #ifdef NEMACS  /* by A.Kato, sanewo,  89.2.21 by K.Handa */
+   Lisp_Object code = XPROCESS (proc)->kanji_code;
+ 
+   if (proc_buffered_char[channel] < 0) {
+     if (NULL (code) || XFASTINT (code) == 0) {
+       nchars = read (channel, chars, sizeof chars);
+       if (nchars == 0) nchars = -1;  /* to show no pending input */
+     } else
+       nchars = kanji_read_from_process (channel, chars, 0,
+ 					sizeof chars, &kanji_mode[channel],
+ 					XFASTINT(code));
+   } else
+ #else  /* not NEMACS */
    if (proc_buffered_char[channel] < 0)
      nchars = read (channel, chars, sizeof chars);
    else
+ #endif  /* not NEMACS */
      {
        chars[0] = proc_buffered_char[channel];
        proc_buffered_char[channel] = -1;
+ #ifdef NEMACS  /* by sanewo,  89.2.21 by K.Handa */
+       if (NULL (code) || XFASTINT (code) == 0) {
+ #endif
        nchars = read (channel, chars + 1, sizeof chars - 1);
        if (nchars < 0)
  	nchars = 1;
        else
  	nchars = nchars + 1;
+ #ifdef NEMACS /* by A.Kato,  89.2.21 by K.Handa */
+       } else
+ 	nchars = kanji_read_from_process (channel, chars, 1,
+ 					  sizeof chars-1, &kanji_mode[channel],
+ 					  XFASTINT(code));
+ #endif
      }
  
+ #ifdef NEMACS  /* 88.5.19  by K.Handa */
+   if (nchars == 0) return 1; else if (nchars < 0) return 0;
+ #else
    if (nchars <= 0) return 0;
+ #endif
  
    outstream = p->filter;
    if (!NULL (outstream))
***************
*** 1647,1656 ****
--- 1750,1774 ----
    /* Don't use register vars; longjmp can lose them.  */
    int rv;
    unsigned char *procname = XSTRING (XPROCESS (proc)->name)->data;
+ #ifdef NEMACS  /* 89.2.22  by K.Handa */
+   char *buf2;
+ #endif
  
    if ((XFASTINT (XPROCESS (proc)->flags) & PROC_STATUS) != RUNNING)
      error ("Process %s not running", procname);
  
+ #ifdef NEMACS  /* 89.2.22  by K.Handa */
+   if (!NULL (XPROCESS(proc)->kanji_code)
+       && XFASTINT(XPROCESS(proc)->kanji_code) != EUC
+       && XFASTINT(XPROCESS(proc)->kanji_code) != NOCONV) {
+     buf2 = get_kanji_work_area(len,
+ 			       XFASTINT(XPROCESS(proc)->kanji_code));
+     len = convert_kanji_code(len, buf, buf2,
+ 			     EUC, XFASTINT(XPROCESS(proc)->kanji_code),
+ 			     to_kanji_process, to_ascii_process);
+     buf = buf2;
+   }
+ #endif
  
    if (!setjmp (send_process_frame))
      while (len > 0)
***************
*** 1684,1689 ****
--- 1802,1810 ----
        deactivate_process (proc);
        error ("SIGPIPE raised on process %s; closed it", procname);
      }
+ #ifdef NEMACS  /* 89.2.22  by K.Handa */
+   free_kanji_work_area();
+ #endif
  }
  
  /*** Is it really safe for this to get an error ?  */
***************
*** 2166,2171 ****
--- 2287,2322 ----
    call2 (sentinel, proc, reason);
    p->sentinel = sentinel;
  }
+ 
+ #ifdef NEMACS  /* 89.2.10  by K.Handa */
+ DEFUN ("process-kanji-code", Fprocess_kanji_code, Sprocess_kanji_code, 0,1,"",
+   "Return kanji code of PROCESS.\n\
+ 0:No-conversion  1:Shift-JIS  2:JIS  3:EUC/AT&T/DEC\n\
+ If no argument, kanji code of the current buffer's process are returned.\n\
+ If PROCESS is not a valid process, NIL is returned.")
+   (proc)
+      register Lisp_Object proc;
+ {
+   if (NULL (proc)) proc = Fget_buffer_process(bf_cur->name);
+   if (XTYPE (proc) != Lisp_Process) return Qnil;
+   return XPROCESS (proc)->kanji_code;
+ }
+ 
+ DEFUN ("set-process-kanji-code", Fset_process_kanji_code,
+        Sset_process_kanji_code, 1, 2, "",
+   "Set PROCESS's kanji code to CODE.\n\
+ 0:No-conversion  1:Shift-JIS  2:JIS  3:EUC/AT&T/DEC\n\
+ If PROCESS is NIL, current buffer's process is applied.")
+   (proc, code)
+      register Lisp_Object proc, code;
+ {
+   if (NULL (proc)) proc = Fget_buffer_process(bf_cur->name);
+   CHECK_PROCESS (proc, 0);
+   CHECK_NUMBER (code, 0);
+   XSET(XPROCESS (proc)->kanji_code, Lisp_Int, XINT (code));
+   return Qnil;
+ }
+ #endif  /* NEMACS */
  
  init_process ()
  {
***************
*** 2184,2189 ****
--- 2335,2343 ----
      {
        chan_process[i] = Qnil;
        proc_buffered_char[i] = -1;
+ #ifdef NEMACS  /* 89.2.10  by K.Handa */
+       kanji_mode[i] = 0;
+ #endif
      }
  }
  
***************
*** 2194,2199 ****
--- 2348,2360 ----
  
    staticpro (&Vprocess_alist);
  
+ #ifdef NEMACS  /* 89.2.10  by K.Handa */
+   Qinvoke_find_kanji_process_code = intern ("invoke-find-kanji-process-code");
+   staticpro (&Qinvoke_find_kanji_process_code);
+   Qfind_kanji_process_code = intern ("find-kanji-process-code");
+   staticpro (&Qfind_kanji_process_code);
+ #endif
+ 
    DEFVAR_BOOL ("delete-exited-processes", &delete_exited_processes,
      "*Non-nil means delete processes immediately when they exit.\n\
  nil means don't delete them until `list-processes' is run.");
***************
*** 2239,2244 ****
--- 2400,2409 ----
    defsubr (&Scontinue_process);
    defsubr (&Sprocess_send_eof);
    defsubr (&Swaiting_for_user_input_p);
+ #ifdef NEMACS  /* 89.2.10  by K.Handa */
+   defsubr (&Sprocess_kanji_code);
+   defsubr (&Sset_process_kanji_code);
+ #endif
  }
  
  #endif subprocesses
diff -arcN emacs-18.55/src/process.h nemacs-3.3.2/src/process.h
*** emacs-18.55/src/process.h	Tue Sep 30 07:42:41 1986
--- nemacs-3.3.2/src/process.h	Wed Jun  6 03:18:43 1990
***************
*** 1,3 ****
--- 1,6 ----
+ /*  89.3.23  modified for Nemacs Ver.3.0 by K.Handa, S.Tomura */
+ /*  89.9.12  modified for Nemacs Ver.3.2 by S.Tomura */
+ 
  /* Definitions for asynchronous process control in GNU Emacs.
     Copyright (C) 1985 Free Software Foundation, Inc.
  
***************
*** 59,64 ****
--- 62,70 ----
      Lisp_Object mark;
      /* Non-nil means kill silently if Emacs is exited.  */
      Lisp_Object kill_without_query;
+ #ifdef NEMACS  /* 89.2.9  by K.Handa */
+     Lisp_Object kanji_code;
+ #endif
  };
  
  /* Process status, found in the flags component */
***************
*** 77,79 ****
--- 83,90 ----
  
  
  #define ChannelMask(n) (1<<(n))
+ 
+ #ifdef NEMACS  /* 89.3.20  by K.Handa */
+ extern Lisp_Object Qfind_kanji_process_code;
+ extern Lisp_Object Qinvoke_find_kanji_process_code;
+ #endif
diff -arcN emacs-18.55/src/puresize.h nemacs-3.3.2/src/puresize.h
*** emacs-18.55/src/puresize.h	Thu Jan  1 09:00:00 1970
--- nemacs-3.3.2/src/puresize.h	Wed Jun  6 03:19:20 1990
***************
*** 0 ****
--- 1,39 ----
+ /* PURESIZE definition file
+    Coded by K.Handa, Electrotechnical Lab. (handa@elt.go.jp)
+ 
+    This file is part of Nemacs (Japanese version of GNU Emacs).
+ 
+    Nemacs is distributed in the forms of patches to GNU
+    Emacs under the terms of the GNU EMACS GENERAL PUBLIC
+    LICENSE which is distributed along with GNU Emacs by the
+    Free Software Foundation.
+ 
+    Nemacs is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied
+    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+    PURPOSE.  See the GNU EMACS GENERAL PUBLIC LICENSE for
+    more details.
+ 
+    You should have received a copy of the GNU EMACS GENERAL
+    PUBLIC LICENSE along with Nemacs; see the file COPYING.
+    If not, write to the Free Software Foundation, 675 Mass
+    Ave, Cambridge, MA 02139, USA. */
+ 
+ /* 90.2.27  created for Nemacs Ver.3.3.1 by K.Handa */
+ 
+ #ifdef NEMACS
+ #undef PURESIZE
+ #ifdef EGG
+ #ifdef HAVE_X_WINDOWS
+ #define PURESIZE 200000
+ #else
+ #define PURESIZE 199000
+ #endif
+ #else  /* not EGG */
+ #ifdef HAVE_X_WINDOWS
+ #define PURESIZE 146000
+ #else
+ #define PURESIZE 142000
+ #endif
+ #endif  /* not EGG */
+ #endif  /* not NEMACS */
